Subject: bug#52905: 29.0.50; "fixed-pitch" face doesn't respect the font in "default-frame-alist"

From: Eli Zaretskii <[email-masked]>
Date: Sat, 01 Jan 2022 22:28:34 +0200

> From: Dima Kogan <[email-masked]>
> Cc: [email-masked]
> Date: Sat, 01 Jan 2022 11:07:50 -0800
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> Is using the default-frame-alist to set the default font still our
> >> recommended best practice? Is that what you do?
> >
> > Yes and yes.  It's just that you seem to interpret "the default font"
> > differently from what it was supposed to mean.  It means the font of
> > the default face.  Any face that doesn't specify a font or some font
> > attribute will use the same font, but faces that do specify those
> > attributes can (and usually do) select other fonts.  To affect the
> > font of the faces which specify font attributes, you need to customize
> > those faces separately from the default face and default-frame-alist.
> 
> Hi. Let's talk about this part first. Clearly the manual says what you
> describe, and I clearly see how it came to be this way. It makes perfect
> sense from the viewpoint of the dev that wrote the logic and the docs.
> 
> As a user, this doesn't feel right to me, though. Can we talk about
> that? Then we can agree on what, if anything, needs fixing.
> 
> Do you use org? Are you seeing a different fonts in the body of the
> document compared to the #+begin_... lines? If so, does this bug you?
> The org devs said
> 
>   #+begin_... lines should be rendered with the fixed-pitch face font
> 
> I suspect that what they MEANT was
> 
>   #+begin_... lines should be rendered with a fixed pitch font

No, I think they meant what they said.

> I suspect this because that's what I would have meant if I wrote it. IF
> this is what was intended and IF the default font had a fixed pitch,
> then I think it makes sense for emacs to use the default font here.
> 
> If you're seeing the two different fonts, and you think that's fine,
> then I'll just fix this in my .emacs, and we can be done.

Yes, I think it is fine to see 2 different fonts in this case.  Once
again, the reason is that the fixed-pitch face specifies its own font.